---
title: '@namespace'
slug: Web/CSS/@namespace
tags:
  - At-rule
  - CSS
  - CSS Namespaces
  - Layout
  - Reference
  - Web
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary"><strong><code>@namespace</code></strong> is an <a href="/en-US/docs/Web/CSS/At-rule" title="CSS at-rules">at-rule</a> that defines <a href="/en-US/docs/Namespaces">XML namespaces</a> to be used in a <a href="/en-US/docs/Glossary/CSS">CSS</a> <a href="/en-US/docs/Web/API/StyleSheet">style sheet</a>.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css notranslate">/* Default namespace */
@namespace url(<em>XML-namespace-URL</em>);
@namespace "<em>XML-namespace-URL</em>";

/* Prefixed namespace */
@namespace <em>prefix</em> url(<em>XML-namespace-URL</em>);
@namespace <em>prefix</em> "<em>XML-namespace-URL</em>";</pre>

<h2 id="Description">Description</h2>

<p>The defined namespaces can be used to restrict the <a href="/en-US/docs/Web/CSS/Universal_selectors">universal</a>, <a href="/en-US/docs/Web/CSS/Type_selectors">type</a>, and <a href="/en-US/docs/Web/CSS/Attribute_selectors">attribute</a> <a href="/en-US/docs/Web/Guide/CSS/Getting_started/Selectors">selectors</a> to only select elements within that namespace. The <code>@namespace</code> rule is generally only useful when dealing with documents containing multiple namespaces—such as HTML5 with inline SVG or MathML, or XML that mixes multiple vocabularies.</p>

<p>Any <code>@namespace</code> rules must follow all <a href="/en-US/docs/Web/CSS/%40charset">@charset</a> and <a href="/en-US/docs/Web/CSS/%40import">@import</a> rules, and precede all other at-rules and <a href="/en-US/docs/Web/API/CSSStyleDeclaration">style declarations</a> in a style sheet.</p>

<p><code>@namespace</code> can be used to define the <strong>default namespace</strong> for the style sheet. When a default namespace is defined, all universal and type selectors (but not attribute selectors, see note below) apply only to elements in that namespace.</p>

<p>The <code>@namespace</code> rule can also be used to define a <strong>namespace prefix</strong>. When a universal, type, or attribute selector is prefixed with a namespace prefix, then that selector only matches if the namespace <em>and</em> name of the element or attribute matches.</p>

<p>In <a href="/en-US/docs/Glossary/HTML5">HTML5</a>, known <a href="https://html.spec.whatwg.org/#foreign-elements">foreign elements</a> will automatically be assigned namespaces. This means that HTML elements will act as though they are in the XHTML namespace (<code>http://www.w3.org/1999/xhtml</code>), even if there is no <code>xmlns</code> attribute anywhere in the document, and the <a href="/en-US/docs/Web/SVG/Element/svg">&lt;svg&gt;</a> and <a href="/en-US/docs/Web/MathML/Element/math">&lt;math&gt;</a> elements will be assigned their proper namespaces (<code>http://www.w3.org/2000/svg</code> and <code>http://www.w3.org/1998/Math/MathML</code>).</p>

<div class="note">
<p><strong>Note:</strong> In XML, unless a prefix is defined directly on an attribute (<em>e.g.</em>, <code>xlink:href</code>), that attribute has no namespace. In other words, attributes do not inherit the namespace of the element they're on. To match this behaviour, the default namespace in CSS does not apply to attribute selectors.</p>
</div>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Specifying_default_and_prefixed_namespaces">Specifying default and prefixed namespaces</h3>

<pre class="brush: css no-line-numbers notranslate">@namespace url(http://www.w3.org/1999/xhtml);
@namespace svg url(http://www.w3.org/2000/svg);

/* This matches all XHTML &lt;a&gt; elements, as XHTML is the default unprefixed namespace */
a {}

/* This matches all SVG &lt;a&gt; elements */
svg|a {}

/* This matches both XHTML and SVG &lt;a&gt; elements */
*|a {}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Namespaces', '#declaration', '@namespace')}}</td>
   <td>{{Spec2('CSS3 Namespaces')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.at-rules.namespace")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/SVG/Namespaces_Crash_Course">Namespaces crash course</a></li>
</ul>
